﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml.Data;

namespace GridVirtualization
{
    public sealed class ViewModel
    {
        public ObservableCollection<Movie> Movies = new ObservableCollection<Movie>();

        public CollectionViewSource GroupedMovies = new CollectionViewSource();

        public void GetMovies()
        {
            Movies = new ObservableCollection<Movie>(DataModel.GetMovies());
        }

        public void GroupMovies()
        {
            GroupedMovies.IsSourceGrouped = true;
            GroupedMovies.Source = from m in DataModel.GetMovies()
                                   group m by "Group #" + ((m.Id % 5) + 1).ToString() into g
                                   orderby g.Key
                                   select g;
        }
    }
}
