using System;
using System.Threading;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238
namespace CancelAsyncWinRT
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        private CancellationTokenSource Cts;
        
        private async void Download_Click(object sender, RoutedEventArgs e)
        {
            Cts = new CancellationTokenSource();
        
            var feedUri = new Uri("http://windowsteamblog.com/windows/b/developers/atom.aspx");
            var client = new Windows.Web.Syndication.SyndicationClient();
            
            // Disable cache, so method runs for a while
            client.BypassCacheOnRetrieve = true;
            
            var feed = client.RetrieveFeedAsync(feedUri).AsTask(Cts.Token);
            
            try
            {
                Output.Text = (await feed).Title.Text;
            }
            catch (OperationCanceledException)
            {
                Output.Text = "Cancelled";
            }
        }
        
        private void Cancel_Click(object sender, RoutedEventArgs e)
        {
            Cts.Cancel();
        }
    }
}