using System;
using System.Text;
using Windows.UI.Xaml.Data;

namespace Startup
{
    public class FormatNameConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var text = value as String;
            if (text == null) return value;

            var sb = new StringBuilder();

            foreach (var c in text)
            {
                if (Char.IsUpper(c))
                {
                    sb.Append(" ");
                }
                sb.Append(c);
            }

            // For illustration purposes only, don't do this
            SimulateCPUBoundWork();

            return sb;
        }

        // This method is only for illustration, don't use this
        private static void SimulateCPUBoundWork()
        {
            var ms = DateTime.Now.Millisecond;
            while (ms == DateTime.Now.Millisecond) ;
        }

        // ConvertBack isn't needed, but it is part of the interface so it must be implemented
        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}