private ObservableCollection<Photo> photos = new ObservableCollection<Photo>();

public PicturePage()
{
    this.InitializeComponent();
    SetDataContext();

    this.navigationHelper = new NavigationHelper(this);
    this.navigationHelper.LoadState += navigationHelper_LoadState;
    this.navigationHelper.SaveState += navigationHelper_SaveState;
}

private async Task SetDataContext()
{
    var pictures = KnownFolders.PicturesLibrary;

    foreach (var file in await pictures.GetFilesAsync())
    {
        var thumbnail = await file.GetThumbnailAsync(ThumbnailMode.PicturesView);

        if (thumbnail != null)
        {
            using (thumbnail)
            {
                var source = new BitmapImage();
                await source.SetSourceAsync(thumbnail);
        
                photos.Add(new Photo { Thumbnail = source });
            }
        }
    }

    DataContext = photos;
}