private async Task SetDataContext()
{
    var pictures = KnownFolders.PicturesLibrary;

    DataContext = photos;
  
    foreach (var file in await pictures.GetFilesAsync())
    {
        var thumbnail = await file.GetThumbnailAsync(ThumbnailMode.PicturesView);
    
        if (thumbnail != null)
        {
            using (thumbnail)
            {
                var source = new BitmapImage();
                await source.SetSourceAsync(thumbnail);
        
                photos.Add(new Photo { Thumbnail = source });
            }
        }
    }
}